--- httpd-2.2.11-clean/modules/mappers/mod_rewrite.c	2008-08-18 17:39:36.000000000 +0200
+++ httpd-2.2.11/modules/mappers/mod_rewrite.c	2009-05-18 18:31:07.000000000 +0200
@@ -2345,9 +2345,12 @@
     char *tok_cntx;
     char *cookie;
 
-    var = apr_strtok(s, ":", &tok_cntx);
-    val = apr_strtok(NULL, ":", &tok_cntx);
-    domain = apr_strtok(NULL, ":", &tok_cntx);
+    // see if we're using ";" as a separator, if not default back to old behaviour with ":"
+    char sep = strchr(s, ';') ? sep = ';' : ':';
+
+    var = apr_strtok(s, &sep, &tok_cntx);
+    val = apr_strtok(NULL, &sep, &tok_cntx);
+    domain = apr_strtok(NULL, &sep, &tok_cntx);
 
     if (var && val && domain) {
         request_rec *rmain = r;
@@ -2363,10 +2366,10 @@
         if (!data) {
             char *exp_time = NULL;
 
-            expires = apr_strtok(NULL, ":", &tok_cntx);
-            path = expires ? apr_strtok(NULL, ":", &tok_cntx) : NULL;
-            secure = path ? apr_strtok(NULL, ":", &tok_cntx) : NULL;
-            httponly = secure ? apr_strtok(NULL, ":", &tok_cntx) : NULL;
+            expires = apr_strtok(NULL, &sep, &tok_cntx);
+            path = expires ? apr_strtok(NULL, &sep, &tok_cntx) : NULL;
+            secure = path ? apr_strtok(NULL, &sep, &tok_cntx) : NULL;
+            httponly = secure ? apr_strtok(NULL, &sep, &tok_cntx) : NULL;
 
             if (expires) {
                 apr_time_exp_t tms;
